package contacts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewDeleteCharactersCharacterIDContactsParams creates a new DeleteCharactersCharacterIDContactsParams object
// with the default values initialized.
func NewDeleteCharactersCharacterIDContactsParams() *DeleteCharactersCharacterIDContactsParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &DeleteCharactersCharacterIDContactsParams{
		Datasource: &datasourceDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteCharactersCharacterIDContactsParamsWithTimeout creates a new DeleteCharactersCharacterIDContactsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewDeleteCharactersCharacterIDContactsParamsWithTimeout(timeout time.Duration) *DeleteCharactersCharacterIDContactsParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &DeleteCharactersCharacterIDContactsParams{
		Datasource: &datasourceDefault,

		timeout: timeout,
	}
}

// NewDeleteCharactersCharacterIDContactsParamsWithContext creates a new DeleteCharactersCharacterIDContactsParams object
// with the default values initialized, and the ability to set a context for a request
func NewDeleteCharactersCharacterIDContactsParamsWithContext(ctx context.Context) *DeleteCharactersCharacterIDContactsParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &DeleteCharactersCharacterIDContactsParams{
		Datasource: &datasourceDefault,

		Context: ctx,
	}
}

/*DeleteCharactersCharacterIDContactsParams contains all the parameters to send to the API endpoint
for the delete characters character id contacts operation typically these are written to a http.Request
*/
type DeleteCharactersCharacterIDContactsParams struct {

	/*CharacterID
	  ID for a character

	*/
	CharacterID int32
	/*ContactIds
	  A list of contacts to edit

	*/
	ContactIds []int32
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the delete characters character id contacts params
func (o *DeleteCharactersCharacterIDContactsParams) WithTimeout(timeout time.Duration) *DeleteCharactersCharacterIDContactsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete characters character id contacts params
func (o *DeleteCharactersCharacterIDContactsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete characters character id contacts params
func (o *DeleteCharactersCharacterIDContactsParams) WithContext(ctx context.Context) *DeleteCharactersCharacterIDContactsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete characters character id contacts params
func (o *DeleteCharactersCharacterIDContactsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithCharacterID adds the characterID to the delete characters character id contacts params
func (o *DeleteCharactersCharacterIDContactsParams) WithCharacterID(characterID int32) *DeleteCharactersCharacterIDContactsParams {
	o.SetCharacterID(characterID)
	return o
}

// SetCharacterID adds the characterId to the delete characters character id contacts params
func (o *DeleteCharactersCharacterIDContactsParams) SetCharacterID(characterID int32) {
	o.CharacterID = characterID
}

// WithContactIds adds the contactIds to the delete characters character id contacts params
func (o *DeleteCharactersCharacterIDContactsParams) WithContactIds(contactIds []int32) *DeleteCharactersCharacterIDContactsParams {
	o.SetContactIds(contactIds)
	return o
}

// SetContactIds adds the contactIds to the delete characters character id contacts params
func (o *DeleteCharactersCharacterIDContactsParams) SetContactIds(contactIds []int32) {
	o.ContactIds = contactIds
}

// WithDatasource adds the datasource to the delete characters character id contacts params
func (o *DeleteCharactersCharacterIDContactsParams) WithDatasource(datasource *string) *DeleteCharactersCharacterIDContactsParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the delete characters character id contacts params
func (o *DeleteCharactersCharacterIDContactsParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteCharactersCharacterIDContactsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	// path param character_id
	if err := r.SetPathParam("character_id", swag.FormatInt32(o.CharacterID)); err != nil {
		return err
	}

	if err := r.SetBodyParam(o.ContactIds); err != nil {
		return err
	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
