package contacts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetCharactersCharacterIDContactsParams creates a new GetCharactersCharacterIDContactsParams object
// with the default values initialized.
func NewGetCharactersCharacterIDContactsParams() *GetCharactersCharacterIDContactsParams {
	var (
		datasourceDefault = string("tranquility")
		pageDefault       = int32(1)
	)
	return &GetCharactersCharacterIDContactsParams{
		Datasource: &datasourceDefault,
		Page:       &pageDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetCharactersCharacterIDContactsParamsWithTimeout creates a new GetCharactersCharacterIDContactsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetCharactersCharacterIDContactsParamsWithTimeout(timeout time.Duration) *GetCharactersCharacterIDContactsParams {
	var (
		datasourceDefault = string("tranquility")
		pageDefault       = int32(1)
	)
	return &GetCharactersCharacterIDContactsParams{
		Datasource: &datasourceDefault,
		Page:       &pageDefault,

		timeout: timeout,
	}
}

// NewGetCharactersCharacterIDContactsParamsWithContext creates a new GetCharactersCharacterIDContactsParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetCharactersCharacterIDContactsParamsWithContext(ctx context.Context) *GetCharactersCharacterIDContactsParams {
	var (
		datasourceDefault = string("tranquility")
		pageDefault       = int32(1)
	)
	return &GetCharactersCharacterIDContactsParams{
		Datasource: &datasourceDefault,
		Page:       &pageDefault,

		Context: ctx,
	}
}

/*GetCharactersCharacterIDContactsParams contains all the parameters to send to the API endpoint
for the get characters character id contacts operation typically these are written to a http.Request
*/
type GetCharactersCharacterIDContactsParams struct {

	/*CharacterID
	  ID for a character

	*/
	CharacterID int32
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*Page
	  page integer

	*/
	Page *int32

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get characters character id contacts params
func (o *GetCharactersCharacterIDContactsParams) WithTimeout(timeout time.Duration) *GetCharactersCharacterIDContactsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get characters character id contacts params
func (o *GetCharactersCharacterIDContactsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get characters character id contacts params
func (o *GetCharactersCharacterIDContactsParams) WithContext(ctx context.Context) *GetCharactersCharacterIDContactsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get characters character id contacts params
func (o *GetCharactersCharacterIDContactsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithCharacterID adds the characterID to the get characters character id contacts params
func (o *GetCharactersCharacterIDContactsParams) WithCharacterID(characterID int32) *GetCharactersCharacterIDContactsParams {
	o.SetCharacterID(characterID)
	return o
}

// SetCharacterID adds the characterId to the get characters character id contacts params
func (o *GetCharactersCharacterIDContactsParams) SetCharacterID(characterID int32) {
	o.CharacterID = characterID
}

// WithDatasource adds the datasource to the get characters character id contacts params
func (o *GetCharactersCharacterIDContactsParams) WithDatasource(datasource *string) *GetCharactersCharacterIDContactsParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the get characters character id contacts params
func (o *GetCharactersCharacterIDContactsParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithPage adds the page to the get characters character id contacts params
func (o *GetCharactersCharacterIDContactsParams) WithPage(page *int32) *GetCharactersCharacterIDContactsParams {
	o.SetPage(page)
	return o
}

// SetPage adds the page to the get characters character id contacts params
func (o *GetCharactersCharacterIDContactsParams) SetPage(page *int32) {
	o.Page = page
}

// WriteToRequest writes these params to a swagger request
func (o *GetCharactersCharacterIDContactsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	// path param character_id
	if err := r.SetPathParam("character_id", swag.FormatInt32(o.CharacterID)); err != nil {
		return err
	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	if o.Page != nil {

		// query param page
		var qrPage int32
		if o.Page != nil {
			qrPage = *o.Page
		}
		qPage := swag.FormatInt32(qrPage)
		if qPage != "" {
			if err := r.SetQueryParam("page", qPage); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
