package fleets

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetFleetsFleetIDParams creates a new GetFleetsFleetIDParams object
// with the default values initialized.
func NewGetFleetsFleetIDParams() *GetFleetsFleetIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetFleetsFleetIDParams{
		Datasource: &datasourceDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetFleetsFleetIDParamsWithTimeout creates a new GetFleetsFleetIDParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetFleetsFleetIDParamsWithTimeout(timeout time.Duration) *GetFleetsFleetIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetFleetsFleetIDParams{
		Datasource: &datasourceDefault,

		timeout: timeout,
	}
}

// NewGetFleetsFleetIDParamsWithContext creates a new GetFleetsFleetIDParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetFleetsFleetIDParamsWithContext(ctx context.Context) *GetFleetsFleetIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetFleetsFleetIDParams{
		Datasource: &datasourceDefault,

		Context: ctx,
	}
}

/*GetFleetsFleetIDParams contains all the parameters to send to the API endpoint
for the get fleets fleet id operation typically these are written to a http.Request
*/
type GetFleetsFleetIDParams struct {

	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*FleetID
	  ID for a fleet

	*/
	FleetID int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get fleets fleet id params
func (o *GetFleetsFleetIDParams) WithTimeout(timeout time.Duration) *GetFleetsFleetIDParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get fleets fleet id params
func (o *GetFleetsFleetIDParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get fleets fleet id params
func (o *GetFleetsFleetIDParams) WithContext(ctx context.Context) *GetFleetsFleetIDParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get fleets fleet id params
func (o *GetFleetsFleetIDParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithDatasource adds the datasource to the get fleets fleet id params
func (o *GetFleetsFleetIDParams) WithDatasource(datasource *string) *GetFleetsFleetIDParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the get fleets fleet id params
func (o *GetFleetsFleetIDParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithFleetID adds the fleetID to the get fleets fleet id params
func (o *GetFleetsFleetIDParams) WithFleetID(fleetID int64) *GetFleetsFleetIDParams {
	o.SetFleetID(fleetID)
	return o
}

// SetFleetID adds the fleetId to the get fleets fleet id params
func (o *GetFleetsFleetIDParams) SetFleetID(fleetID int64) {
	o.FleetID = fleetID
}

// WriteToRequest writes these params to a swagger request
func (o *GetFleetsFleetIDParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	// path param fleet_id
	if err := r.SetPathParam("fleet_id", swag.FormatInt64(o.FleetID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
