package fleets

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewPutFleetsFleetIDParams creates a new PutFleetsFleetIDParams object
// with the default values initialized.
func NewPutFleetsFleetIDParams() *PutFleetsFleetIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PutFleetsFleetIDParams{
		Datasource: &datasourceDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewPutFleetsFleetIDParamsWithTimeout creates a new PutFleetsFleetIDParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewPutFleetsFleetIDParamsWithTimeout(timeout time.Duration) *PutFleetsFleetIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PutFleetsFleetIDParams{
		Datasource: &datasourceDefault,

		timeout: timeout,
	}
}

// NewPutFleetsFleetIDParamsWithContext creates a new PutFleetsFleetIDParams object
// with the default values initialized, and the ability to set a context for a request
func NewPutFleetsFleetIDParamsWithContext(ctx context.Context) *PutFleetsFleetIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PutFleetsFleetIDParams{
		Datasource: &datasourceDefault,

		Context: ctx,
	}
}

/*PutFleetsFleetIDParams contains all the parameters to send to the API endpoint
for the put fleets fleet id operation typically these are written to a http.Request
*/
type PutFleetsFleetIDParams struct {

	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*FleetID
	  ID for a fleet

	*/
	FleetID int64
	/*NewSettings
	  What to update for this fleet

	*/
	NewSettings PutFleetsFleetIDBody

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the put fleets fleet id params
func (o *PutFleetsFleetIDParams) WithTimeout(timeout time.Duration) *PutFleetsFleetIDParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the put fleets fleet id params
func (o *PutFleetsFleetIDParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the put fleets fleet id params
func (o *PutFleetsFleetIDParams) WithContext(ctx context.Context) *PutFleetsFleetIDParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the put fleets fleet id params
func (o *PutFleetsFleetIDParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithDatasource adds the datasource to the put fleets fleet id params
func (o *PutFleetsFleetIDParams) WithDatasource(datasource *string) *PutFleetsFleetIDParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the put fleets fleet id params
func (o *PutFleetsFleetIDParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithFleetID adds the fleetID to the put fleets fleet id params
func (o *PutFleetsFleetIDParams) WithFleetID(fleetID int64) *PutFleetsFleetIDParams {
	o.SetFleetID(fleetID)
	return o
}

// SetFleetID adds the fleetId to the put fleets fleet id params
func (o *PutFleetsFleetIDParams) SetFleetID(fleetID int64) {
	o.FleetID = fleetID
}

// WithNewSettings adds the newSettings to the put fleets fleet id params
func (o *PutFleetsFleetIDParams) WithNewSettings(newSettings PutFleetsFleetIDBody) *PutFleetsFleetIDParams {
	o.SetNewSettings(newSettings)
	return o
}

// SetNewSettings adds the newSettings to the put fleets fleet id params
func (o *PutFleetsFleetIDParams) SetNewSettings(newSettings PutFleetsFleetIDBody) {
	o.NewSettings = newSettings
}

// WriteToRequest writes these params to a swagger request
func (o *PutFleetsFleetIDParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	// path param fleet_id
	if err := r.SetPathParam("fleet_id", swag.FormatInt64(o.FleetID)); err != nil {
		return err
	}

	if err := r.SetBodyParam(o.NewSettings); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
