package mail

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewDeleteCharactersCharacterIDMailLabelsLabelIDParams creates a new DeleteCharactersCharacterIDMailLabelsLabelIDParams object
// with the default values initialized.
func NewDeleteCharactersCharacterIDMailLabelsLabelIDParams() *DeleteCharactersCharacterIDMailLabelsLabelIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &DeleteCharactersCharacterIDMailLabelsLabelIDParams{
		Datasource: &datasourceDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteCharactersCharacterIDMailLabelsLabelIDParamsWithTimeout creates a new DeleteCharactersCharacterIDMailLabelsLabelIDParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewDeleteCharactersCharacterIDMailLabelsLabelIDParamsWithTimeout(timeout time.Duration) *DeleteCharactersCharacterIDMailLabelsLabelIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &DeleteCharactersCharacterIDMailLabelsLabelIDParams{
		Datasource: &datasourceDefault,

		timeout: timeout,
	}
}

// NewDeleteCharactersCharacterIDMailLabelsLabelIDParamsWithContext creates a new DeleteCharactersCharacterIDMailLabelsLabelIDParams object
// with the default values initialized, and the ability to set a context for a request
func NewDeleteCharactersCharacterIDMailLabelsLabelIDParamsWithContext(ctx context.Context) *DeleteCharactersCharacterIDMailLabelsLabelIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &DeleteCharactersCharacterIDMailLabelsLabelIDParams{
		Datasource: &datasourceDefault,

		Context: ctx,
	}
}

/*DeleteCharactersCharacterIDMailLabelsLabelIDParams contains all the parameters to send to the API endpoint
for the delete characters character id mail labels label id operation typically these are written to a http.Request
*/
type DeleteCharactersCharacterIDMailLabelsLabelIDParams struct {

	/*CharacterID
	  An EVE character ID

	*/
	CharacterID int32
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*LabelID
	  An EVE label id

	*/
	LabelID int32

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the delete characters character id mail labels label id params
func (o *DeleteCharactersCharacterIDMailLabelsLabelIDParams) WithTimeout(timeout time.Duration) *DeleteCharactersCharacterIDMailLabelsLabelIDParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete characters character id mail labels label id params
func (o *DeleteCharactersCharacterIDMailLabelsLabelIDParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete characters character id mail labels label id params
func (o *DeleteCharactersCharacterIDMailLabelsLabelIDParams) WithContext(ctx context.Context) *DeleteCharactersCharacterIDMailLabelsLabelIDParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete characters character id mail labels label id params
func (o *DeleteCharactersCharacterIDMailLabelsLabelIDParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithCharacterID adds the characterID to the delete characters character id mail labels label id params
func (o *DeleteCharactersCharacterIDMailLabelsLabelIDParams) WithCharacterID(characterID int32) *DeleteCharactersCharacterIDMailLabelsLabelIDParams {
	o.SetCharacterID(characterID)
	return o
}

// SetCharacterID adds the characterId to the delete characters character id mail labels label id params
func (o *DeleteCharactersCharacterIDMailLabelsLabelIDParams) SetCharacterID(characterID int32) {
	o.CharacterID = characterID
}

// WithDatasource adds the datasource to the delete characters character id mail labels label id params
func (o *DeleteCharactersCharacterIDMailLabelsLabelIDParams) WithDatasource(datasource *string) *DeleteCharactersCharacterIDMailLabelsLabelIDParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the delete characters character id mail labels label id params
func (o *DeleteCharactersCharacterIDMailLabelsLabelIDParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithLabelID adds the labelID to the delete characters character id mail labels label id params
func (o *DeleteCharactersCharacterIDMailLabelsLabelIDParams) WithLabelID(labelID int32) *DeleteCharactersCharacterIDMailLabelsLabelIDParams {
	o.SetLabelID(labelID)
	return o
}

// SetLabelID adds the labelId to the delete characters character id mail labels label id params
func (o *DeleteCharactersCharacterIDMailLabelsLabelIDParams) SetLabelID(labelID int32) {
	o.LabelID = labelID
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteCharactersCharacterIDMailLabelsLabelIDParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	// path param character_id
	if err := r.SetPathParam("character_id", swag.FormatInt32(o.CharacterID)); err != nil {
		return err
	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	// path param label_id
	if err := r.SetPathParam("label_id", swag.FormatInt32(o.LabelID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
