package market

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetMarketsStructuresStructureIDParams creates a new GetMarketsStructuresStructureIDParams object
// with the default values initialized.
func NewGetMarketsStructuresStructureIDParams() *GetMarketsStructuresStructureIDParams {
	var (
		datasourceDefault = string("tranquility")
		pageDefault       = int32(1)
	)
	return &GetMarketsStructuresStructureIDParams{
		Datasource: &datasourceDefault,
		Page:       &pageDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetMarketsStructuresStructureIDParamsWithTimeout creates a new GetMarketsStructuresStructureIDParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetMarketsStructuresStructureIDParamsWithTimeout(timeout time.Duration) *GetMarketsStructuresStructureIDParams {
	var (
		datasourceDefault = string("tranquility")
		pageDefault       = int32(1)
	)
	return &GetMarketsStructuresStructureIDParams{
		Datasource: &datasourceDefault,
		Page:       &pageDefault,

		timeout: timeout,
	}
}

// NewGetMarketsStructuresStructureIDParamsWithContext creates a new GetMarketsStructuresStructureIDParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetMarketsStructuresStructureIDParamsWithContext(ctx context.Context) *GetMarketsStructuresStructureIDParams {
	var (
		datasourceDefault = string("tranquility")
		pageDefault       = int32(1)
	)
	return &GetMarketsStructuresStructureIDParams{
		Datasource: &datasourceDefault,
		Page:       &pageDefault,

		Context: ctx,
	}
}

/*GetMarketsStructuresStructureIDParams contains all the parameters to send to the API endpoint
for the get markets structures structure id operation typically these are written to a http.Request
*/
type GetMarketsStructuresStructureIDParams struct {

	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*Page
	  Which page to query, only used for querying without type_id. Starting at 1


	*/
	Page *int32
	/*StructureID
	  Return orders in this region

	*/
	StructureID int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get markets structures structure id params
func (o *GetMarketsStructuresStructureIDParams) WithTimeout(timeout time.Duration) *GetMarketsStructuresStructureIDParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get markets structures structure id params
func (o *GetMarketsStructuresStructureIDParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get markets structures structure id params
func (o *GetMarketsStructuresStructureIDParams) WithContext(ctx context.Context) *GetMarketsStructuresStructureIDParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get markets structures structure id params
func (o *GetMarketsStructuresStructureIDParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithDatasource adds the datasource to the get markets structures structure id params
func (o *GetMarketsStructuresStructureIDParams) WithDatasource(datasource *string) *GetMarketsStructuresStructureIDParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the get markets structures structure id params
func (o *GetMarketsStructuresStructureIDParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithPage adds the page to the get markets structures structure id params
func (o *GetMarketsStructuresStructureIDParams) WithPage(page *int32) *GetMarketsStructuresStructureIDParams {
	o.SetPage(page)
	return o
}

// SetPage adds the page to the get markets structures structure id params
func (o *GetMarketsStructuresStructureIDParams) SetPage(page *int32) {
	o.Page = page
}

// WithStructureID adds the structureID to the get markets structures structure id params
func (o *GetMarketsStructuresStructureIDParams) WithStructureID(structureID int64) *GetMarketsStructuresStructureIDParams {
	o.SetStructureID(structureID)
	return o
}

// SetStructureID adds the structureId to the get markets structures structure id params
func (o *GetMarketsStructuresStructureIDParams) SetStructureID(structureID int64) {
	o.StructureID = structureID
}

// WriteToRequest writes these params to a swagger request
func (o *GetMarketsStructuresStructureIDParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	if o.Page != nil {

		// query param page
		var qrPage int32
		if o.Page != nil {
			qrPage = *o.Page
		}
		qPage := swag.FormatInt32(qrPage)
		if qPage != "" {
			if err := r.SetQueryParam("page", qPage); err != nil {
				return err
			}
		}

	}

	// path param structure_id
	if err := r.SetPathParam("structure_id", swag.FormatInt64(o.StructureID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
