package universe

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// New creates a new universe API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) *Client {
	return &Client{transport: transport, formats: formats}
}

/*
Client for universe API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

/*
GetUniverseCategories gets item categories

Get a list of item categories

---

Alternate route: `/v1/universe/categories/`

Alternate route: `/legacy/universe/categories/`

Alternate route: `/dev/universe/categories/`


---

This route is cached for up to 3600 seconds
*/
func (a *Client) GetUniverseCategories(params *GetUniverseCategoriesParams) (*GetUniverseCategoriesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetUniverseCategoriesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "get_universe_categories",
		Method:             "GET",
		PathPattern:        "/universe/categories/",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{""},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &GetUniverseCategoriesReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetUniverseCategoriesOK), nil

}

/*
GetUniverseCategoriesCategoryID gets item category information

Get information of an item category

---

Alternate route: `/v1/universe/categories/{category_id}/`

Alternate route: `/legacy/universe/categories/{category_id}/`

Alternate route: `/dev/universe/categories/{category_id}/`


---

This route is cached for up to 3600 seconds
*/
func (a *Client) GetUniverseCategoriesCategoryID(params *GetUniverseCategoriesCategoryIDParams) (*GetUniverseCategoriesCategoryIDOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetUniverseCategoriesCategoryIDParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "get_universe_categories_category_id",
		Method:             "GET",
		PathPattern:        "/universe/categories/{category_id}/",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{""},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &GetUniverseCategoriesCategoryIDReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetUniverseCategoriesCategoryIDOK), nil

}

/*
GetUniverseGroups gets item groups

Get a list of item groups

---

Alternate route: `/v1/universe/groups/`

Alternate route: `/legacy/universe/groups/`

Alternate route: `/dev/universe/groups/`


---

This route is cached for up to 3600 seconds
*/
func (a *Client) GetUniverseGroups(params *GetUniverseGroupsParams) (*GetUniverseGroupsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetUniverseGroupsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "get_universe_groups",
		Method:             "GET",
		PathPattern:        "/universe/groups/",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{""},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &GetUniverseGroupsReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetUniverseGroupsOK), nil

}

/*
GetUniverseGroupsGroupID gets item group information

Get information on an item group

---

Alternate route: `/v1/universe/groups/{group_id}/`

Alternate route: `/legacy/universe/groups/{group_id}/`

Alternate route: `/dev/universe/groups/{group_id}/`


---

This route is cached for up to 3600 seconds
*/
func (a *Client) GetUniverseGroupsGroupID(params *GetUniverseGroupsGroupIDParams) (*GetUniverseGroupsGroupIDOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetUniverseGroupsGroupIDParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "get_universe_groups_group_id",
		Method:             "GET",
		PathPattern:        "/universe/groups/{group_id}/",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{""},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &GetUniverseGroupsGroupIDReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetUniverseGroupsGroupIDOK), nil

}

/*
GetUniverseRaces gets character races

Get a list of character races

---

Alternate route: `/v1/universe/races/`

Alternate route: `/legacy/universe/races/`

Alternate route: `/dev/universe/races/`


---

This route is cached for up to 3600 seconds
*/
func (a *Client) GetUniverseRaces(params *GetUniverseRacesParams) (*GetUniverseRacesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetUniverseRacesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "get_universe_races",
		Method:             "GET",
		PathPattern:        "/universe/races/",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{""},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &GetUniverseRacesReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetUniverseRacesOK), nil

}

/*
GetUniverseStationsStationID gets station information

Public information on stations

---

Alternate route: `/v1/universe/stations/{station_id}/`

Alternate route: `/legacy/universe/stations/{station_id}/`

Alternate route: `/dev/universe/stations/{station_id}/`


---

This route is cached for up to 3600 seconds
*/
func (a *Client) GetUniverseStationsStationID(params *GetUniverseStationsStationIDParams) (*GetUniverseStationsStationIDOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetUniverseStationsStationIDParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "get_universe_stations_station_id",
		Method:             "GET",
		PathPattern:        "/universe/stations/{station_id}/",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{""},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &GetUniverseStationsStationIDReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetUniverseStationsStationIDOK), nil

}

/*
GetUniverseStructures lists all public structures

List all public structures

---

Alternate route: `/v1/universe/structures/`

Alternate route: `/legacy/universe/structures/`

Alternate route: `/dev/universe/structures/`


---

This route is cached for up to 3600 seconds
*/
func (a *Client) GetUniverseStructures(params *GetUniverseStructuresParams) (*GetUniverseStructuresOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetUniverseStructuresParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "get_universe_structures",
		Method:             "GET",
		PathPattern:        "/universe/structures/",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{""},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &GetUniverseStructuresReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetUniverseStructuresOK), nil

}

/*
GetUniverseStructuresStructureID gets structure information

Returns information on requested structure, if you are on the ACL. Otherwise, returns "Forbidden" for all inputs.

---

Alternate route: `/v1/universe/structures/{structure_id}/`

Alternate route: `/legacy/universe/structures/{structure_id}/`

Alternate route: `/dev/universe/structures/{structure_id}/`

*/
func (a *Client) GetUniverseStructuresStructureID(params *GetUniverseStructuresStructureIDParams, authInfo runtime.ClientAuthInfoWriter) (*GetUniverseStructuresStructureIDOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetUniverseStructuresStructureIDParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "get_universe_structures_structure_id",
		Method:             "GET",
		PathPattern:        "/universe/structures/{structure_id}/",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{""},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &GetUniverseStructuresStructureIDReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetUniverseStructuresStructureIDOK), nil

}

/*
GetUniverseSystemsSystemID gets solar system information

Information on solar systems

---

Alternate route: `/v1/universe/systems/{system_id}/`

Alternate route: `/legacy/universe/systems/{system_id}/`

Alternate route: `/dev/universe/systems/{system_id}/`


---

This route is cached for up to 3600 seconds
*/
func (a *Client) GetUniverseSystemsSystemID(params *GetUniverseSystemsSystemIDParams) (*GetUniverseSystemsSystemIDOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetUniverseSystemsSystemIDParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "get_universe_systems_system_id",
		Method:             "GET",
		PathPattern:        "/universe/systems/{system_id}/",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{""},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &GetUniverseSystemsSystemIDReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetUniverseSystemsSystemIDOK), nil

}

/*
GetUniverseTypes gets types

Get a list of type ids

---

Alternate route: `/v1/universe/types/`

Alternate route: `/legacy/universe/types/`

Alternate route: `/dev/universe/types/`


---

This route is cached for up to 3600 seconds
*/
func (a *Client) GetUniverseTypes(params *GetUniverseTypesParams) (*GetUniverseTypesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetUniverseTypesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "get_universe_types",
		Method:             "GET",
		PathPattern:        "/universe/types/",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{""},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &GetUniverseTypesReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetUniverseTypesOK), nil

}

/*
GetUniverseTypesTypeID gets type information

Get information on a type

---

Alternate route: `/v2/universe/types/{type_id}/`

Alternate route: `/dev/universe/types/{type_id}/`


---

This route is cached for up to 3600 seconds
*/
func (a *Client) GetUniverseTypesTypeID(params *GetUniverseTypesTypeIDParams) (*GetUniverseTypesTypeIDOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetUniverseTypesTypeIDParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "get_universe_types_type_id",
		Method:             "GET",
		PathPattern:        "/universe/types/{type_id}/",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{""},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &GetUniverseTypesTypeIDReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetUniverseTypesTypeIDOK), nil

}

/*
PostUniverseNames gets names and categories for a set of ID s

Resolve a set of IDs to names and categories. Supported ID's for resolving are: Characters, Corporations, Alliances, Stations, Solar Systems, Constellations, Regions, Types.

---

Alternate route: `/v1/universe/names/`

Alternate route: `/legacy/universe/names/`

*/
func (a *Client) PostUniverseNames(params *PostUniverseNamesParams) (*PostUniverseNamesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostUniverseNamesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "post_universe_names",
		Method:             "POST",
		PathPattern:        "/universe/names/",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{""},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &PostUniverseNamesReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*PostUniverseNamesOK), nil

}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
